import static org.junit.Assert.*;

import org.junit.Test;


public class SingleLinkedListTest {

   /** Test to see that the initial list is empty */
    @Test
    public void test1() {
        SingleLinkedList testInstance = new SingleLinkedList();
        assertEquals(0, testInstance.size());
    }

    /**
     * Test to see that the get method throws an
     * exception on an empty list
     */
    @Test(expected = IndexOutOfBoundsException.class)
    public void test2() {
        SingleLinkedList testInstance = new SingleLinkedList();
        assertNull(testInstance.get(0));
    }

    /** Test to see that add method inserts an item */
    /*
    @Test
    public void test3() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("[tom]");
        assertEquals(1, testInstance.size());
        assertEquals("[tom]", testInstance.toString());
    }
 */

    /** Test to see that add method inserts three items */
    @Test
    public void test4() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add("harry");
        assertEquals(3, testInstance.size());
        assertEquals("[tom ==> laura ==> harry]", testInstance.toString());
    }

    /** Test the get method on a list of three items */
    @Test
    public void test5() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add("harry");
        assertEquals("tom", testInstance.get(0));
        assertEquals("laura", testInstance.get(1));
        assertEquals("harry", testInstance.get(2));
    }

    
    /** Test the add method to see if it adds in the middle */
    /*
    @Test
    public void test6() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add(1, "sam");
        assertEquals(4, testInstance.size());
        assertEquals("[tom ==> sam ==> laura ==> harry]",
                testInstance.toString());
    }
 */
    
    /** Test the add method to see if it adds in the middle */
    /*
    @Test
    public void test7() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add("harry");
        testInstance.add(2, "sam");
        assertEquals(4, testInstance.size());
        assertEquals("[tom ==> laura => sam ==> harry]",
                testInstance.toString());
    }
    */

    /** Test the add method to see if it adds at the beginning */
    @Test
    public void test8() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add("harry");
        testInstance.add(0, "sam");
        assertEquals(4, testInstance.size());
        assertEquals("[sam ==> tom ==> laura ==> harry]",
                testInstance.toString());
    }

    /** Test the add method to see if it adds at the end */
    /*
    @Test
    public void test9() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        testInstance.add("tom");
        testInstance.add("laura");
        testInstance.add("harry");
        testInstance.add(3, "sam");
        assertEquals(4, testInstance.size());
        assertEquals("[tom ==> harry ==> sam]",
                testInstance.toString());
    }
    */

    
    
    //////////////////////////   Remove Part   /////////////////////////////////////
    
    // Test the remove(item) method on an empty list 
    @Test
    public void test10() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        assertFalse(testInstance.remove("tom"));
    }

    
    // Test the remove method on an empty list 
    @Test(expected = IndexOutOfBoundsException.class)
    public void test11() {
        SingleLinkedList<String> testInstance = new SingleLinkedList<String>();
        assertEquals("tom", testInstance.remove(0));
    }

    /*
    // Test the remove method on a list with only one item 
    @Test
    public void test12() {
    }

    // Test the remove method by removing the first item 
    @Test
    public void test13() {
    }

    // Test the remove method by removing the middle item 
    @Test
    public void test14() {
    }

    // Test the remove method by removing the last item 
    @Test
    public void test15() {
    }

   
    // Test the remove(item) method on a list with one item 
    @Test
    public void test16() {
    }

    // Test the remove(item) from the first item of a list 
    @Test
    public void test17() {
    }

    // Test the remove(item) from the second item of a list 
    @Test
    public void test18() {
    }

    // Test the remove(item) from the third item of a list 
    @Test
    public void test19() {
    }

    // Test the remove(item) from the last item of a list 
    @Test
    public void test20() 
    }
*/


}
